﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InstanceTest
{
    class Bus
        : Car
    {
        //プロパティ==========
        public int SalesAmount { get; private set; }        //運賃
        public int PassengerNumber { get; private set; }    //乗客人数

        //コンストラクタ==========
        public Bus()
            : this(100)
        {
        }

        public Bus(double gas)
            : base(gas)
        {
            this.SalesAmount = 0;
            this.PassengerNumber = 0;
        }

        //メソッド==========
        //乗車させるメソッド
        public void RideToBus(int fare)
        {
            //走行中かどうか
            if (this.Speed != 0)
            {
                throw new WarningException("停車してください。");
            }
            //満席かどうか
            if (this.PassengerNumber >= 50)
            {
                throw new WarningException("満席のため、乗車できません。");
            }
            //料金と、乗車人数を加算
            this.SalesAmount += fare;
            this.PassengerNumber++;
        }

        //降車させるメソッド
        public void GetOffBus()
        {
            //走行中かどうか
            if (this.Speed != 0)
            {
                throw new WarningException("停車してください。");
            }
            //乗客がいるかどうか
            if (this.PassengerNumber == 0)
            {
                throw new WarningException("乗客はいません。");
            }
            //乗車人数を減算
            this.PassengerNumber--;
        }
    }
}
